// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from polygon_msgs:msg/Polygon2D.idl
// generated code does not contain a copyright notice
#include "polygon_msgs/msg/detail/polygon2_d__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `points`
#include "polygon_msgs/msg/detail/point2_d__functions.h"

bool
polygon_msgs__msg__Polygon2D__init(polygon_msgs__msg__Polygon2D * msg)
{
  if (!msg) {
    return false;
  }
  // points
  if (!polygon_msgs__msg__Point2D__Sequence__init(&msg->points, 0)) {
    polygon_msgs__msg__Polygon2D__fini(msg);
    return false;
  }
  return true;
}

void
polygon_msgs__msg__Polygon2D__fini(polygon_msgs__msg__Polygon2D * msg)
{
  if (!msg) {
    return;
  }
  // points
  polygon_msgs__msg__Point2D__Sequence__fini(&msg->points);
}

bool
polygon_msgs__msg__Polygon2D__are_equal(const polygon_msgs__msg__Polygon2D * lhs, const polygon_msgs__msg__Polygon2D * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // points
  if (!polygon_msgs__msg__Point2D__Sequence__are_equal(
      &(lhs->points), &(rhs->points)))
  {
    return false;
  }
  return true;
}

bool
polygon_msgs__msg__Polygon2D__copy(
  const polygon_msgs__msg__Polygon2D * input,
  polygon_msgs__msg__Polygon2D * output)
{
  if (!input || !output) {
    return false;
  }
  // points
  if (!polygon_msgs__msg__Point2D__Sequence__copy(
      &(input->points), &(output->points)))
  {
    return false;
  }
  return true;
}

polygon_msgs__msg__Polygon2D *
polygon_msgs__msg__Polygon2D__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  polygon_msgs__msg__Polygon2D * msg = (polygon_msgs__msg__Polygon2D *)allocator.allocate(sizeof(polygon_msgs__msg__Polygon2D), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(polygon_msgs__msg__Polygon2D));
  bool success = polygon_msgs__msg__Polygon2D__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
polygon_msgs__msg__Polygon2D__destroy(polygon_msgs__msg__Polygon2D * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    polygon_msgs__msg__Polygon2D__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
polygon_msgs__msg__Polygon2D__Sequence__init(polygon_msgs__msg__Polygon2D__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  polygon_msgs__msg__Polygon2D * data = NULL;

  if (size) {
    data = (polygon_msgs__msg__Polygon2D *)allocator.zero_allocate(size, sizeof(polygon_msgs__msg__Polygon2D), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = polygon_msgs__msg__Polygon2D__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        polygon_msgs__msg__Polygon2D__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
polygon_msgs__msg__Polygon2D__Sequence__fini(polygon_msgs__msg__Polygon2D__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      polygon_msgs__msg__Polygon2D__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

polygon_msgs__msg__Polygon2D__Sequence *
polygon_msgs__msg__Polygon2D__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  polygon_msgs__msg__Polygon2D__Sequence * array = (polygon_msgs__msg__Polygon2D__Sequence *)allocator.allocate(sizeof(polygon_msgs__msg__Polygon2D__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = polygon_msgs__msg__Polygon2D__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
polygon_msgs__msg__Polygon2D__Sequence__destroy(polygon_msgs__msg__Polygon2D__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    polygon_msgs__msg__Polygon2D__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
polygon_msgs__msg__Polygon2D__Sequence__are_equal(const polygon_msgs__msg__Polygon2D__Sequence * lhs, const polygon_msgs__msg__Polygon2D__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!polygon_msgs__msg__Polygon2D__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
polygon_msgs__msg__Polygon2D__Sequence__copy(
  const polygon_msgs__msg__Polygon2D__Sequence * input,
  polygon_msgs__msg__Polygon2D__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(polygon_msgs__msg__Polygon2D);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    polygon_msgs__msg__Polygon2D * data =
      (polygon_msgs__msg__Polygon2D *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!polygon_msgs__msg__Polygon2D__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          polygon_msgs__msg__Polygon2D__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!polygon_msgs__msg__Polygon2D__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
